class_name Player
extends CharacterBody3D


@export var speed: float = 5.0
@export var jump_velocity: float = 4.5


func _physics_process(delta: float) -> void:
	apply_gravity(delta)
	handle_jump()
	handle_movement()

	move_and_slide()


func apply_gravity(delta: float) -> void:
	if is_on_floor(): return
	velocity += get_gravity() * delta

func handle_jump() -> void:
	if not Input.is_action_just_pressed("jump") or not is_on_floor(): return
	velocity.y = jump_velocity

func handle_movement() -> void:
	var input_dir: Vector2 = Input.get_vector("move_left", "move_right", "move_forward", "move_backward")
	var direction: Vector3 = (transform.basis * Vector3(input_dir.x, 0, input_dir.y)).normalized()
	if direction:
		velocity.x = direction.x * speed
		velocity.z = direction.z * speed
	else:
		velocity.x = move_toward(velocity.x, 0, speed)
		velocity.z = move_toward(velocity.z, 0, speed)
